#ifndef EDGELOAD_H
#define EDGELOAD_H

#include "../../GEFEL/siftop.h"
#include "../SRC/alias.h"
#include <stdio.h>

/**
  This class is used for edge load in the mechprep preprocessor.
  Edge load is defined only on the linear edge of the solved 2D solid and is
  described by the points of the edge and values in these points in the each direction.
  The linear approximation is used for the edge load values

*/
class edgeload
{
  public :
   edgeload();
   ~edgeload();
   long read(FILE *in, long lc);
   long getval(snode *tn, double *nv);

   long ndir; ///< number of load directions
   long nlc;  ///< load case number
   double xa; ///< x-coordinate of the point a
   double ya; ///< y-coordinate of the point a
   double za; ///< z-coordinate of the point a
   double xb; ///< x-coordinate of the point b
   double yb; ///< y-coordinate of the point b
   double zb; ///< z-coordinate of the point b
   double *fa; ///< array with load values in the point a
   double *fb; ///< array with load values in the point b
};

#endif
