#ifndef ELSURFLOAD_H
#define ELSURFLOAD_H

#include "../../GEFEL/siftop.h"
#include "../SRC/alias.h"
#include <stdio.h>

/**
  This class is used for element surface load in the mechprep preprocessor.
  The load is defined on the surfaces on given elements and 
  it can be defined in the global or local coordinate system of the given surface.
*/
class elsurfload
{
  public :
   elsurfload();
   ~elsurfload();
   long read(FILE *in, long lc);

   long nlc;   ///< load case number
   long nsurf; ///< number of surfaces on given elements
   long ndir;  ///< number of load directions
   long *lgcs; ///< global(1)/local(2) coordinate system indicator for each surface on element
   double *f;  ///< array with load values  
};

#endif
