#include "tempload.h"
#include "intools.h"

/**
  This constructor initializes class attributes to the zero values.
*/
tempload::tempload()
{
  nlc = 0L;
  val = 0.0;
}


/**
  Destructor
*/
tempload::~tempload()
{
}

/**
  This function reads temperature load data from the MEFEL preprocessor file given by the
  parameter in.
  Parameters :
  @param in - pointer to the opened text file
  @param lc - total number of load cases

  Returns :
  @retval 0 - on success
  @retval 1 - invalid load case number
  @retval 2 - error reading temperature value
*/
long tempload::read(FILE *in, long lc)
{
  if (getlong(in, nlc))
    return 1L;
  if ((nlc < 1) && (nlc > lc))
    return 1L;
  if (getdouble(in, val))
    return 2L;
  return 0L;
}
