#include "crsec3d.h"
#include "global.h"
#include "stochdriver.h"

crsec3d::crsec3d (void)
{
  rho=0.0;
}
crsec3d::~crsec3d (void)
{
  
}

void crsec3d::read (XFILE *in)
{
  switch (Mp->tprob){
  case linear_statics:{
    xfscanf (in,"%lf",&rho);
    break;
  }
  case eigen_dynamics:{
    xfscanf (in,"%lf",&rho);
    break;
  }
  case forced_dynamics:{
    xfscanf (in,"%lf",&rho);
    break;
  }
  case mat_nonlinear_statics:{
    xfscanf (in,"%lf",&rho);
    break;
  }
  case growing_mech_structure:
  case mech_timedependent_prob:{
    xfscanf (in,"%lf",&rho);
    break;
  }
  default:{
    fprintf (stderr,"\n\n unknown problem type is required in function");
    fprintf (stderr,"\n read (file %s, line %d).\n",__FILE__,__LINE__);
  }
  }
}

void crsec3d::changeparam (atsel &atcs,vector &val)
{
  long i;
  
  for (i=0;i<atcs.num;i++){
    switch (atcs.atrib[i]){
    case 0:{
      rho=val[i];
      break;
    }
    default:{
      fprintf (stderr,"\n\n wrong number of atribute in function changeparam (file %s, line %d).\n",__FILE__,__LINE__);
    }
    }
  }
}
