#include "loadn.h"
#include "global.h"
#include "gtopology.h"
#include "intools.h"
#include "stochdriver.h"

loadn::loadn()
{
  nid = nlc = 0L;
  f = NULL;
}

loadn::~loadn()
{
  delete [] f;
}

long loadn::read(XFILE *in)
{
  long ndofn;

  xfscanf(in, "%ld",&nid);
  if (nid<1)
    fprintf (stderr,"\n\n number of loaded node in function loadn::read (file %s, line %d) is nonpositive",__FILE__,__LINE__);
  if (nid>Mt->nn){
    fprintf (stderr,"\n\n number of loaded node in function loadn::read (file %s, line %d)",__FILE__,__LINE__);
    fprintf (stderr,"\n is greater than total number of nodes.\n");
  }
  nid--;
  ndofn = Mt->give_ndofn (nid);
  f = new double [ndofn];
  for (long i = 0; i < ndofn; i++)
    xfscanf(in, "%le", &f[i]);
  return(0);
}

long loadn::read_prop(FILE *in, long ndof, long lc)
{
  getlong(in, nlc);
  if ((nlc < 1) || (nlc > lc))
    return(2);
  f = new double [ndof];
  for (long i = 0; i < ndof; i++)
    getdouble(in, f[i]);
  return(0);
}

void loadn::changeparam (atsel &atln,vector &val)
{
  long i;
  
  for (i=0;i<atln.num;i++){
    f[atln.atrib[i]]=val[i];
  }
  
}
