#ifndef MTSOLVER_H
#define MTSOLVER_H

#include <stdio.h>
#include "selection.h"
#include "timecontr.h"

void solve_time_dep_prob ();

void visco_solver (long lcid);
void one_step (long lcid, long n, double *f, double *fi, double *fp, double *fb, double *dr, double *r);

void aux_nonlintime_print (FILE *aux, double *r, double l);
void mtsolver_save (double *r, double *fp, long ni, double time, double dt, timecontr &tc, long n);
void mtsolver_save_text (double *r, double *fp, long ni, double time, double dt, timecontr &tc, long n);
void mtsolver_save_binary (double *r, double *fp, long ni, double time, double dt, timecontr &tc, long n);
void mtsolver_save_text_single (double *r, double *fp, long ni, double time, double dt, timecontr &tc, long n);
void mtsolver_save_text_multiple (double *r, double *fp, long ni, double time, double dt, timecontr &tc, long n);
void mtsolver_save_binary_single (double *r, double *fp, long ni, double time, double dt, timecontr &tc, long n);
void mtsolver_save_binary_multiple (double *r, double *fp, long ni, double time, double dt, timecontr &tc, long n);
void mtsolver_restore (double *r, double *fp, long &ni, double &time, double &dt, timecontr &tc, long &n);
void mtsolver_restore_text (double *r, double *fp, long &ni, double &time, double &dt, timecontr &tc, long &n);
void mtsolver_restore_binary (double *r, double *fp, long &ni, double &time, double &dt, timecontr &tc, long &n);
void mtsolver_restore_text_single (double *r, double *fp, long &ni, double &time, double &dt, timecontr &tc, long &n);
void mtsolver_restore_text_multiple (double *r, double *fp, long &ni, double &time, double &dt, timecontr &tc, long &n);
void mtsolver_restore_binary_single (double *r,double *fp,long &ni,double &time, double &dt, timecontr &tc, long &n);
void mtsolver_restore_binary_multiple (double *r,double *fp,long &ni,double &time, double &dt, timecontr &tc, long &n);


#endif
