#ifndef PLQUADCONTACT_H
#define PLQUADCONTACT_H

#include "alias.h"

struct matrix;
struct vector;
struct ivector;



/**
   class plquadcontact is plane quadrilateral element for contact problems
   
   basic data
   nne = 4 - number nodes on element
   ndofe = 8 - number of DOFs on element
   
   JK, 11.6.2006
*/
class plquadcontact
{
 public:
  plquadcontact (void);
  ~plquadcontact (void);

  void eleminit (long eid);
  void transf_matrix (ivector &nod,matrix &tmat);

  void stiffness_matrix (long eid,long ri,long ci,matrix &sm,vector &x,vector &y);
  void res_stiffness_matrix (long lcid,long eid,matrix &sm);

  void res_mainip_strains (long lcid,long eid);
  void mainip_strains (long lcid,long eid,long ri,long ci,vector &x,vector &y,vector &r);
  
  void internal_forces (long lcid,long eid,long ri,long ci,vector &ifor,vector &x,vector &y);
  void res_internal_forces (long lcid,long eid,vector &ifor);

  
  ///  number of DOFs on the element
  long ndofe;
  ///  number of nodes on one element
  long nne;
  ///  total number of components of stress and strain tensors
  long tncomp;
  ///  total number of integration points on element
  long tnip;
  ///  array containing numbers of components of stress and strain tensors
  long *ncomp;
  ///  array containing cumulative numbers of components of stress and strain tensors
    //long *cncomp;
  ///  number of approximated functions on the element
    //long napfun;
  ///  number of edges
    //long ned;
  ///  number of nodes on one edge
    //long nned;
  ///  array containing orders of numerical integration of stiffness matrix
    //long **intordsm;
  ///  order of integration of mass matrix
    //long intordmm;
  ///  order of integration on edges
    //long intordb;
  ///  array of numbers of integration points in sets
  long **nip;
  ///  number of blocks
  long nb;
  ///  stress/strain state
    //strastrestate ssst;

    };


#endif
